class ColorPickerForm of FORM
   with (this)
      onOpen = class::FORM_ONOPEN
      height = 18.6364
      left = 28.1429
      top = 0.1364
      width = 76.4286
      text = "Color Picker"
      showTaskBarButton = false
   endwith

   this.CONTAINER1 = new CONTAINER(this)
   with (this.CONTAINER1)
      left = 0.0
      top = 17.1364
      width = 76.4286
      height = 1.5
      anchor = 1  // Bottom
   endwith

   this.CONTAINER1.PUSHBUTTON1 = new PUSHBUTTON(this.CONTAINER1)
   with (this.CONTAINER1.PUSHBUTTON1)
      onClick = class::PUSHBUTTON1_ONCLICK
      height = 1.0909
      left = 20
      top = 0.0455
      width = 15.0
      text = "OK"
      pageno = 0
   endwith

   this.CONTAINER1.PUSHBUTTON2 = new PUSHBUTTON(this.CONTAINER1)
   with (this.CONTAINER1.PUSHBUTTON2)
      onClick = class::PUSHBUTTON2_ONCLICK
      height = 1.0909
      left = 36
      top = 0.0455
      width = 15.0
      text = "Cancel"
      pageno = 0
   endwith

   this.ACTIVEX1 = new ACTIVEX(this)
   with (this.ACTIVEX1)
      height = 17.1364
      left = 0.0
      top = 0.0
      width = 76.4286
      l0 = "FNBBBBBBPCEHBBBBJODHBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBFNBBBBBBBBBBBBBBBBBBBBBBBCBBBBBBPBOBGIBBIEEGNQCCLPHKBJBBDMDPCDHDBJBBBBBBBBBBBBBBFNBBBBBBBCCFBDBBBBBBBBBBNBBBBBBBBBBBBBFHJBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
      l0 += "BBBBBBBBBBBBBBBBBCBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
      state = l0
      classId = "{8856F961-340A-11D0-A96B-00C04FD705A2}"
      anchor = 6  // Container
   endwith


   function PUSHBUTTON1_onClick
      x = form.activex1.nativeobject.document.body.innerhtml
      n = at("<FORM name=f><INPUT size=7 value=", x )
      cColor = substr(x,n+len("<FORM name=f><INPUT size=7 value="),7)
      if "#" $ cColor
         form.colorPick = cColor
      else
         form.colorPick = ""
      endif
      form.close()
      return

   function PUSHBUTTON2_onClick
      form.colorPick = ""
      form.close()
      return

   function form_onOpen
      cPath = set('dire')
      form.activex1.nativeobject.navigate2(cPath+"\ColorPicker.htm")
      return
endclass

class PreviewHTMLForm of FORM
   with (this)
      onOpen = class::FORM_ONOPEN
      onClose = class::FORM_ONCLOSE
      metric = 6  // Pixels
      height = 328.0
      left = 164.0
      top = 29.0
      width = 700.0
      text = "Web Reports Preview"
      mdi = false
      showTaskBarButton = false
   endwith

   this.ACTIVEX1 = new ACTIVEX(this)
   with (this.ACTIVEX1)
      height = 328.0
      left = 0.0
      top = 0.0
      width = 700.0
      borderStyle = 2   // Lowered
      l0 = "FNBBBBBBDFFJBBBBMCDCBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBFNBBBBBBBBBBBBBBBBBBBBBBBCBBBBBBPBOBGIBBIEEGNQCCLPHKBJBBDMDPCDHDBNBBBBBBBBBBBBBBFNBBBBBBBCCFBDBBBBBBBBBBNBBBBBBBBBBBBBFHJBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
      l0 += "BBBBBBBBBBBBBBBBBCBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
      state = l0
      classId = "{8856F961-340A-11D0-A96B-00C04FD705A2}"
      anchor = 6  // Container
   endwith


   function form_onClose
      new file().delete(form.HTMLPage)
      return

   function form_onOpen
      if type('form.HTMLPage') # "U"
         // A page has been passed by the calling routine
         //form.showPage(form.HTMLPage)
         form.activex1.nativeobject.navigate2(form.HTMLPage)
      else
         form.showPage("tempPreview.htm")    
      endif


      return

   function showPage(cPage)
      local cPath
      cPath = set('DIRE') 
      do while at('\',cPath) > 0
         cPath = stuff(cPath,at('\',cPath),1,'/')
      enddo
      //  Format the path as a URL; assumes the help
      //  files are in a subfolder named help
      cPath = 'file:///' + cPath + '/'
      form.activex1.nativeobject.navigate2(cPath + cPage)
      return
endclass


class TemplateForm of FORM
   with (this)
      onOpen = class::FORM_ONOPEN
      height = 6.0
      left = 49.0
      top = 0.7727
      width = 36.8571
      text = ""
      autoCenter = true
   endwith

   this.COMBOBOX1 = new COMBOBOX(this)
   with (this.COMBOBOX1)
      onOpen = class::COMBOBOX1_ONOPEN
      height = 1.0
      left = 5.0
      top = 2.0
      width = 27.0
      style = 1   // DropDown
   endwith

   this.ENTRYFIELD1 = new ENTRYFIELD(this)
   with (this.ENTRYFIELD1)
      height = 1.0
      left = 5.0
      top = 2.0
      width = 27.0
      value = ""
   endwith

   this.TEXTLABEL1 = new TEXTLABEL(this)
   with (this.TEXTLABEL1)
      height = 1.0
      left = 5.0
      top = 1.0
      width = 27.0
      text = "Textlabel1"
   endwith

   this.PUSHBUTTON1 = new PUSHBUTTON(this)
   with (this.PUSHBUTTON1)
      onClick = class::PUSHBUTTON1_ONCLICK
      height = 1.0909
      left = 7.0
      top = 3.5
      width = 11.2857
      text = "OK"
   endwith

   this.PUSHBUTTON2 = new PUSHBUTTON(this)
   with (this.PUSHBUTTON2)
      onClick = {||form.close()}
      height = 1.0909
      left = 19.0
      top = 3.5
      width = 11.2857
      text = "Cancel"
   endwith


   function COMBOBOX1_onOpen
      local f
      this.a = new array()
      f = new file()
      f.open(set('dire')+"\options.ini")
      do while not f.eof()
         s = f.gets()
         if form.mode = 'restore' and s = '[' and upper(s) <> "[WEBSITE]" 

            this.a.add(substr(s,2,len(s)-2))
            
         elseif form.mode = "delete" ; 
            and s = '[' and upper(s) <> "[WEBSITE]" ;
            and upper(s) <> "[DEFAULT.TEMPLATE]"

            this.a.add(substr(s,2,len(s)-2))

         endif
      enddo
      this.datasource = "Array this.a"
      
      return

   function PUSHBUTTON1_onClick
      if type("form.mode") # "U"
         if form.mode = 'save'
            cSection = form.entryfield1.value
            form.oParent.saveTemplate(cSection)
         elseif form.mode = 'restore'
            cSection = form.combobox1.value
            form.oParent.restoreTemplate(cSection)
         elseif form.mode = 'delete'
            cSection = form.combobox1.value
            form.oParent.deleteTemplate(cSection)
         else
            msgbox('Error') 
         endif
      endif
      form.close()
      return

   function form_onOpen
      this.entryfield1.visible = false
      this.combobox1.visible = false
      if type("this.mode") # "U"
         if this.mode = 'save'
            this.text = "Create a new template"
            this.textlabel1.text = "Enter a template name" 
            this.entryfield1.visible = true
            this.entryfield1.setFocus()
         elseif this.mode = 'restore'
            this.text = "Restore a template"
            this.textlabel1.text = "Select a template to restore"
            //this.combobox1.a.add("")
            //this.combobox1.a.insert(1)
            //this.combobox1.a[1] = "Default.Template"
            //this.combobox1.datasource = "Array this.combobox1.a"
            this.combobox1.visible = true
         elseif this.mode = 'delete'
            this.text = "Delete a template"
            this.textlabel1.text = "Select a template to delete"
            this.combobox1.visible = true
         else
            this.textlabel1.text = "There is nothing to do"
         endif
      endif
      return
endclass

class help1Form of FORM
   with (this)
      onOpen = class::FORM_ONOPEN
      metric = 6	// Pixels
      height = 328.0
      left = 16.0
      top = 30.0
      width = 478.0
      text = "Help - Web Reports Wizard"
      showTaskBarButton = false
      icon = "resource #13"
   endwith

   this.CONTAINER1 = new CONTAINER(this)
   with (this.CONTAINER1)
      left = 0.0
      top = 0.0
      width = 478.0
      height = 25.0
      borderStyle = 3	// None
      anchor = 2	// Top
   endwith

   this.CONTAINER1.PUSHBUTTON1 = new PUSHBUTTON(this.CONTAINER1)
   with (this.CONTAINER1.PUSHBUTTON1)
      onClick = class::PUSHBUTTON1_ONCLICK
      height = 22.0
      left = 0.0
      top = 0.0
      width = 50.0
      text = "Back"
      pageno = 0
   endwith

   this.CONTAINER1.PUSHBUTTON2 = new PUSHBUTTON(this.CONTAINER1)
   with (this.CONTAINER1.PUSHBUTTON2)
      onClick = class::PUSHBUTTON2_ONCLICK
      height = 22.0
      left = 51.0
      top = 0.0
      width = 50.0
      text = "Home"
      pageno = 0
   endwith

   this.ACTIVEX1 = new ACTIVEX(this)
   with (this.ACTIVEX1)
      height = 303.0
      left = 0.0
      top = 25.0
      width = 478.0
      borderStyle = 2	// Lowered
      l0 = "FNBBBBBBEDECBBBBCNCQBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBFNBBBBBBBBBBBBBBBBBBBBBBBCBBBBBBPBOBGIBBIEEGNQCCLPHKBJBBDMDPCDHDBNBBBBBBBBBBBBBBFNBBBBBBBCCFBDBBBBBBBBBBNBBBBBBBBBBBBBFHJBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
      l0 += "BBBBBBBBBBBBBBBBBCBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
      state = l0
      classId = "{8856F961-340A-11D0-A96B-00C04FD705A2}"
      anchor = 6	// Container
   endwith


   function form_onOpen
      if type('form.helpPage') # "U"
         // A page has been passed by the calling routine
         form.showPage(form.helpPage)
      else
         form.showPage("Docs\index.htm")    
      endif
      return

   function showPage(cPage)
      local cPath
      cPath = set('DIRE') 
      do while at('\',cPath) > 0
         cPath = stuff(cPath,at('\',cPath),1,'/')
      enddo
      //  Format the path as a URL; assumes the help
      //  files are in a subfolder named help
      cPath = 'file:///' + cPath + '/'
      form.activex1.nativeobject.navigate2(cPath + cPage)
      return

   function PUSHBUTTON1_onClick
      try
         form.activex1.nativeobject.goback()
      catch (exception e)
         msgbox("Can't navigate back.","Warrning",48)
      endtry
      return

   function PUSHBUTTON2_onClick
      form.showPage( "Docs\index.htm" )
      return

endclass

class AboutForm of FORM
   with (this)
      readModal = class::READMODAL
      metric = 6	// Pixels
      height = 148.0
      left = 0
      top = 0
      width = 280.0
      text = "About"
      autoCenter = true
      mdi = false
      smallTitle = true
      sizeable = false
      sysMenu = false
      escExit = false
      maximize = false
      minimize = false
      icon = "resource #13"
   endwith

   this.TEXT1 = new TEXT(this)
   with (this.TEXT1)
      height = 33.0
      left = 0.0
      top = 0.0
      width = 280.0
      anchor = 2	// Top
      alignVertical = 1	// Middle
      alignHorizontal = 1	// Center
      text = "<h2>Web Reports</h2>"
      borderStyle = 1	// Raised
   endwith

   this.TEXT2 = new TEXT(this)
   with (this.TEXT2)
      height = 55.0
      left = 14.0
      top = 44.0
      width = 252.0
      alignVertical = 1	// Middle
      alignHorizontal = 1	// Center
      text = "<p>Web Reports Wizard, 1.0</p><p> by Michael Nuwer</p><p>Copyright 2003</p>"
      borderStyle = 9	// Etched In
   endwith

   this.TEXT3 = new TEXT(this)
   with (this.TEXT3)
      height = 22.0
      left = 14.0
      top = 121.0
      width = 140.0
      text = "Text3"
   endwith

   this.PUSHBUTTON1 = new PUSHBUTTON(this)
   with (this.PUSHBUTTON1)
      onClick = class::PUSHBUTTON1_ONCLICK
      height = 24.0
      left = 196.0
      top = 115.0
      width = 70.0
      text = "OK"
      //upBitmap = "RESOURCE #20"
   endwith


   function PUSHBUTTON1_onClick
      form.close()
      return

   function ReadModal
      this.text3.Text = "Free memory: " + ;
              ltrim(transform(memory(),"@R 999,999,999K"))
      RETURN super::readmodal()
endclass